clear all;

% load omnicamera picture basename
lbasename=input('Enter omnicamera picture file basename (without number): ','s');
if(isempty(lbasename))
    disp('Input not valid, script stopped.');
    break;
end

fprintf('Basename: %s \n',lbasename)

% load suffix
lsuffix=input('Enter omnicamera filename suffix (without .): ','s');
if(isempty(lsuffix))
    disp('Input not valid, script stopped.');
    break;
end

fprintf('Suffix: %s \n',lsuffix)

lsuffix = strcat('.',lsuffix);

% nacist nejvetsi cislo u souboru
lmaxnum=input('Enter the highest filename number to process: ');

if((lmaxnum - round(lmaxnum)) ~= 0)
    disp('Must be integer, script stopped.');
    break;
elseif (lmaxnum < 0) 
    disp('Must be positive, script stopped.');
    break;    

end


imgOmni = [];
croppedImg = [];
borderOffset = [0 0 0 0 0 0];
newFilename = '';
n_img_h = 0;
n_img_w = 0;
img_h = 0;
img_w = 0;

% pres vsechny soubory
for n = 1:lmaxnum
    
    % existje vubec?
    temp=dir([lbasename sprintf('%d',n) lsuffix]);
    if(~size(temp,1))
    disp(['File ' strcat(lbasename, sprintf('%d',n), lsuffix) ...
        ' not found, skipping.']);
        continue;
    end
    
    imgOmni = imread([lbasename sprintf('%d',n) lsuffix]);
        
    
    img_h = size(imgOmni,1);
    img_w = size(imgOmni,2);
    
    n_img_h = img_w;
    n_img_w = img_h/6;
             
    if((n_img_w - round(n_img_w)) ~= 0)
        disp(['The input image (' [lbasename sprintf('%d',n) lsuffix] ') height (' num2str(img_h) ') is not an integer times 6. Skipping']);
        continue;
    end
    
    for k=1:6
        borderOffset(k) = (k-1)*(n_img_w);
    end
    
    
    croppedImg = zeros(n_img_h,n_img_w,3,'uint8');
    
    
    %Fell free to modify this part to utilize vector operations...
    
    for k = 1:6    
        for m = 1:n_img_h
            for l = 1:n_img_w
               
                
                croppedImg(m,l,:) = imgOmni(n_img_w+1-l+borderOffset(k),m,:);
                
                
            end
        end
        newFilename = sprintf('cam%d_%d.bmp',k-1,n);
        fprintf('Saving %s\n',newFilename);
        imwrite(croppedImg,newFilename,'bmp');
        
    end  
end

disp('Finished');
clear;
close all;