clear all;

%select camera view to crop to

camNum = input('Enter the camera number (0, 1, 2, 3 or 4): ');

if((camNum - round(camNum)) ~= 0)
    disp('Must be integer, aborting.');
    break;
elseif (camNum < 0 || camNum > 5) 
    disp('Must be 0, 1, 2, 3 or 4, aborting.');
    break;    
end

camNum = cast(camNum, 'uint8');

% nacist zaklad jmena souboru lidaru
% enter file basename

lbasename=input('Enter basename of the lidar file (without number or suffix): ','s');
if(isempty(lbasename))
    disp('Nothing entered, aborting.');
    break;
end

fprintf('Basename: %s \n',lbasename)

% nacist priponu
% load suffix

lsuffix=input('Enter lidar file suffix (without .): ','s');
if(isempty(lsuffix))
    disp('Nothing entered, aborting.');
    break;
end

fprintf('Suffix: %s \n',lsuffix)

lsuffix = strcat('.',lsuffix);

% nacist nejvetsi cislo u souboru
% load the highest number
lmaxnum=input('Enter the highest file number: ');

if((lmaxnum - round(lmaxnum)) ~= 0)
    disp('Must be integer, aborting.');
    break;
elseif (lmaxnum < 0) 
    disp('Must be positive, aborting.');
    break;    

end


% projit soubory, importovat, oriznout.
% find files, import and trim


y = 0;
z = 0;
newSize = 0;

% pres vsechny soubory
% through all files
for n = 1:lmaxnum
    
    % existje vubec?
    % check existence
    temp=dir([lbasename sprintf('%d',n) lsuffix]);
    if(~size(temp,1))
    disp(['File ' strcat(lbasename, sprintf('%d',n), lsuffix) ...
        ' not found, skipping.']);
        continue;
    end
    
    % existuje, importujeme
    % it exists, we'll import it
    temp = importdata(strcat(lbasename, sprintf('%d',n), lsuffix));
        
    tempOut = zeros(size(temp,1),3);
    newSize = 0;
    
    %pres vsechny body cloudu 
    %through all lidar points
    for k = 1:size(temp,1)
                
        x = temp(k,1);
        y = temp(k,2);
        z = temp(k,3);
        
        switch(camNum)
        
            case 0
                
                if((x>0) && (y < -0.33*x) && (z<2.5))
                    newSize = newSize+1;
                    tempOut(newSize,:) = [x,y,z];
                end
            case 1
                
                if((x<0) && (y < 0.33*x) && (z<2.5))
                    newSize = newSize+1;
                    tempOut(newSize,:) = [x,y,z];
                end
            case 2
                
                if((y < -1.37*x) && (y > 0.33*x) && (z<2.5))
                    newSize = newSize+1;
                    tempOut(newSize,:) = [x,y,z];
                end
            case 3
                
                if((y > -1.37*x) && (y > 1.37*x) && (z<2.5))
                    newSize = newSize+1;
                    tempOut(newSize,:) = [x,y,z];
                end
            case 4
                
                if((y < 1.37*x) && (y > -0.33*x) && (z<2.5))
                    newSize = newSize+1;
                    tempOut(newSize,:) = [x,y,z];
                end
        end    
    end
    
    tempOut = tempOut(1:newSize,:);
    save(strcat(lbasename,'_view', sprintf('%d',camNum) ,'_', sprintf('%d',n), '.xyz'), 'tempOut', '-ascii');
        
end
